!Program for applying the GN FWI Hessian matrix
program GN_application

	use sep
	use Hess_GN_mod
	use dot_mod
	
	implicit none
	integer 							:: nz, nx, ny
	real								:: dz, dx, dy, oz, ox, oy
	real, dimension(:,:,:),allocatable	:: model, model_out
	character(len=40)					:: wavelet = ' ',sources= ' ',recs= ' ',wavefields= ' ',wantwavefield= ' ',readwavefield= ' ',background_vel= ' ',dt= ' ',threads= ' ',wavefield= ' ',padded= ' '
	
	call sep_init(SOURCE)
	
	call from_history("n1", nz)
  	call from_history("o1", oz)
 	call from_history("d1", dz)
  	call from_history("n2", nx)
  	call from_history("o2", ox)
  	call from_history("d2", dx)
  	call from_history("n3", ny)
  	call from_history("o3", oy)
  	call from_history("d3", dy)
!  	call from_param("wavelet",wavelet)
!  	call from_param("sources",sources)
!  	call from_param("recs",recs)
!  	call from_param("wavefields",wavefields)
!  	call from_param("wantwavefield",wantwavefield)
!  	call from_param("readwavefield",readwavefield)
!  	call from_param("background_vel",background_vel)
!  	call from_param("dt",dt)
!  	call from_param("threads",threads)
!  	call from_param("wavefield",wavefield)
!  	call from_param("padded",padded)
  	

  	
  	allocate(model(nz,nx,ny),model_out(nz,nx,ny))
  	call sep_read(model)
  	
  	!Gauss-Newton Hessian computation routines
  	call Hess_GN_init(nz, nx, ny)
!	call Hess_GN_init(nz,nx,ny,background_vel,wavelet,sources,recs,wavefields,wantwavefield,readwavefield,wavefield,dt,threads,padded)
	call Hess_GN_op(.false., .false., model, model_out)
	!call dotp(Hess_GN_call, nz*nx*ny, nz*nx*ny)
	call Hess_GN_close()
	
	
	call sep_write(model_out)
	call to_history("n1", nz)
  	call to_history("o1", oz)
 	call to_history("d1", dz)
  	call to_history("n2", nx)
  	call to_history("o2", ox)
  	call to_history("d2", dx)
  	call to_history("n3", ny)
  	call to_history("o3", oy)
  	call to_history("d3", dy)
  	
  	deallocate(model_out,model)
  	call sep_close()
  	call exit (0)

end program