!Program for applying the Full FWI Hessian matrix
program Hess_full_application

	use sep
	use Hess_full_mod
	use dot_mod
	
	implicit none
	integer 							:: nz, nx, ny
	real								:: dz, dx, dy, oz, ox, oy
	real, dimension(:,:,:),allocatable	:: model_in, model_out
	
	call sep_init(SOURCE)
	
	call from_history("n1", nz)
  	call from_history("o1", oz)
 	call from_history("d1", dz)
  	call from_history("n2", nx)
  	call from_history("o2", ox)
  	call from_history("d2", dx)
  	call from_history("n3", ny)
  	call from_history("o3", oy)
  	call from_history("d3", dy)
  	
  	
  	allocate(model_in(nz,nx,ny),model_out(nz,nx,ny))
  	call sep_read(model_in)
  	
  	!Gauss-Newton Hessian computation routines
  	call Hess_full_init(nz, nx, ny)
	!call Hess_full_op(.false., .false., model_in, model_out)
	call dotp(Hess_full_call, nz*nx*ny, nz*nx*ny)
	call Hess_full_close()
	
	
	call sep_write(model_out)
	call to_history("n1", nz)
  	call to_history("o1", oz)
 	call to_history("d1", dz)
  	call to_history("n2", nx)
  	call to_history("o2", ox)
  	call to_history("d2", dx)
  	call to_history("n3", ny)
  	call to_history("o3", oy)
  	call to_history("d3", dy)
  	
  	deallocate(model_out,model_in)
  	call sep_close()
  	call exit (0)

end program